SystemOrganization addCategory: #ConfigurationOfMonitoring!

Object subclass: #ConfigurationOfMonitoring
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMonitoring'!

!ConfigurationOfMonitoring class methodsFor: 'development support' stamp: 'NorbertHartl 5/14/2015 12:59'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMonitoring class methodsFor: 'private' stamp: 'NorbertHartl 5/14/2015 12:59'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMonitoring class methodsFor: 'private' stamp: 'NorbertHartl 5/14/2015 12:59'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMonitoring class methodsFor: 'private' stamp: 'NorbertHartl 5/14/2015 12:59'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMonitoring class methodsFor: 'metacello tool support' stamp: 'NorbertHartl 5/14/2015 12:59'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMonitoring class methodsFor: 'loading' stamp: 'NorbertHartl 5/14/2015 12:59'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMonitoring class methodsFor: 'loading' stamp: 'NorbertHartl 5/14/2015 12:59'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMonitoring class methodsFor: 'loading' stamp: 'NorbertHartl 5/14/2015 12:59'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMonitoring class methodsFor: 'accessing' stamp: 'NorbertHartl 5/14/2015 12:59'!
project

	^self new project! !

!ConfigurationOfMonitoring class methodsFor: 'development support' stamp: 'NorbertHartl 5/14/2015 12:59'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMonitoring methodsFor: 'baselines' stamp: 'NorbertHartl 5/16/2015 17:49'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/NorbertHartl/Monitoring/main'.
		spec project: 'NeoJSON' with: [
				spec
					className: #ConfigurationOfNeoJSON;
					versionString: #'stable';
					repository: 'http://mc.stfx.eu/Neo' ].
		spec 
			package: #'Monitor-Core';
			package: #'Monitor-Core-Tests' with: [
				spec requires: #(#'Monitor-Core' ). ];
			package: #'Monitor-JSON' with: [
				spec requires: #('NeoJSON' ). ];
			package: #'Monitor-JSON-Tests' with: [
				spec requires: #(#'Monitor-JSON' ). ];
			package: #'Monitor-Munin';
			package: #'Monitor-Munin-Tests' with: [
				spec requires: #(#'Monitor-Munin' ). ].
		spec 
			group: 'default' with: #(#'Monitor-Core' );
			group: 'tests' with: #(#'Monitor-Core-Tests' #'Monitor-JSON-Tests' #'Monitor-Munin-Tests' );
			group: 'all' with: #('default' #'Monitor-JSON' #'Monitor-Munin' 'tests' ). ].
! !

!ConfigurationOfMonitoring methodsFor: 'baselines' stamp: 'NorbertHartl 5/17/2015 00:27'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/NorbertHartl/Monitoring/main'.
		spec project: 'NeoJSON' with: [
				spec
					className: #ConfigurationOfNeoJSON;
					versionString: #'stable';
					repository: 'http://mc.stfx.eu/Neo' ].
		spec 
			package: #'Monitor-Core';
			package: #'Monitor-Core-Tests' with: [
				spec requires: #(#'Monitor-Core' ). ];
			package: #'Monitor-JSON' with: [
				spec requires: #('NeoJSON' ). ];
			package: #'Monitor-JSON-Tests' with: [
				spec requires: #(#'Monitor-JSON' ). ];
			package: #'Monitor-Munin';
			package: #'Monitor-Munin-Tests' with: [
				spec requires: #(#'Monitor-Munin' ). ].
		spec 
			group: 'default' with: #(#'Monitor-Core' 'munin' 'json' );
			group: 'tests' with: #(#'Monitor-Core-Tests' #'Monitor-JSON-Tests' #'Monitor-Munin-Tests' );
			group: 'all' with: #('default' #'Monitor-JSON' #'Monitor-Munin' 'tests' );
			group: 'munin' with: #(#'Monitor-Munin' );
			group: 'json' with: #(#'Monitor-JSON' ). ].
! !

!ConfigurationOfMonitoring methodsFor: 'accessing' stamp: 'NorbertHartl 5/14/2015 12:59'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfMonitoring methodsFor: 'symbolic versions' stamp: 'NorbertHartl 5/17/2015 00:27'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.2-baseline'.
! !

!ConfigurationOfMonitoring methodsFor: 'accessing' stamp: 'NorbertHartl 5/14/2015 12:59'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMonitoring methodsFor: 'symbolic versions' stamp: 'NorbertHartl 5/17/2015 00:27'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '3'.
! !

!ConfigurationOfMonitoring methodsFor: 'versions' stamp: 'NorbertHartl 5/16/2015 18:06'!
version1: spec
	<version: '1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1'.
		spec author: 'NorbertHartl'.
		spec timestamp: '5/16/2015 18:06'.
		spec project: 'NeoJSON' with: '10'.
		spec 
			package: #'Monitor-Core' with: 'Monitor-Core-NorbertHartl.8';
			package: #'Monitor-Core-Tests' with: 'Monitor-Core-Tests-NorbertHartl.4';
			package: #'Monitor-JSON' with: 'Monitor-JSON-NorbertHartl.5';
			package: #'Monitor-JSON-Tests' with: 'Monitor-JSON-Tests-NorbertHartl.2';
			package: #'Monitor-Munin' with: 'Monitor-Munin-NorbertHartl.6';
			package: #'Monitor-Munin-Tests' with: 'Monitor-Munin-Tests-NorbertHartl.4'. ].
! !

!ConfigurationOfMonitoring methodsFor: 'versions' stamp: 'NorbertHartl 5/17/2015 00:23'!
version2: spec
	<version: '2' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 2'.
		spec author: 'NorbertHartl'.
		spec timestamp: '5/17/2015 00:23'.
		spec project: 'NeoJSON' with: '10'.
		spec 
			package: #'Monitor-Core' with: 'Monitor-Core-NorbertHartl.10';
			package: #'Monitor-Core-Tests' with: 'Monitor-Core-Tests-NorbertHartl.4';
			package: #'Monitor-JSON' with: 'Monitor-JSON-NorbertHartl.5';
			package: #'Monitor-JSON-Tests' with: 'Monitor-JSON-Tests-NorbertHartl.2';
			package: #'Monitor-Munin' with: 'Monitor-Munin-NorbertHartl.10';
			package: #'Monitor-Munin-Tests' with: 'Monitor-Munin-Tests-NorbertHartl.4'. ].
! !

!ConfigurationOfMonitoring methodsFor: 'versions' stamp: 'NorbertHartl 5/17/2015 00:27'!
version3: spec
	<version: '3' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 3'.
		spec author: 'NorbertHartl'.
		spec timestamp: '5/17/2015 00:27'.
		spec project: 'NeoJSON' with: '10'.
		spec 
			package: #'Monitor-Core' with: 'Monitor-Core-NorbertHartl.10';
			package: #'Monitor-Core-Tests' with: 'Monitor-Core-Tests-NorbertHartl.4';
			package: #'Monitor-JSON' with: 'Monitor-JSON-NorbertHartl.5';
			package: #'Monitor-JSON-Tests' with: 'Monitor-JSON-Tests-NorbertHartl.2';
			package: #'Monitor-Munin' with: 'Monitor-Munin-NorbertHartl.10';
			package: #'Monitor-Munin-Tests' with: 'Monitor-Munin-Tests-NorbertHartl.4'. ].
! !
